	if 1==0
	ld a,175;170;99
	add a,0
	ld ($-1),a
xphase=$+1
	ld hl,tcos+80;30
	jr nc,$+3
	inc l
	ld (xphase),hl
	ld a,(hl) ;signed cos
	sra a
	;ld (xspaceshift),a
	
	ld a,243
	add a,0
	ld ($-1),a
yphase=$+1
	ld hl,tcos+80;30
	jr nc,$+3
	inc l
	ld (yphase),hl
	;ld a,(hl) ;signed cos
	;sra a
	;sra a
	;add a,ybase
	;ld (curgouraudybase),a
	ld a,(hl) ;signed cos
	sra a
	;ld (yspaceshift),a
	
	ld a,175;170;99
	add a,0
	ld ($-1),a
xphase=$+1
	ld hl,tcos+80;30
	jr nc,$+3
	inc l
	ld (xphase),hl
	ld a,(hl) ;signed cos
	sra a
	sra a
	add a,xbase
	push af
	srl a
	srl a
	srl a ;8..24
	sub 8
	ld (curbrim),a
	pop af
	and 7
	add a,#80
	ld (curgouraudxbase),a ;64..192

alphaspeed=$+1
	ld a,70
	add a,0
	ld ($-1),a
	ld hl,alpha ; 
	ld a,(hl)
dalpha=$+1
	adc a,0
	;ld (hl),a
betaspeed=$+1
	ld a,13
	add a,0
	ld ($-1),a
	ld hl,beta ;,     (  )
	ld a,(hl)
dbeta=$+1
	adc a,1
	;ld (hl),a
gammaspeed=$+1
	ld a,10;103
	add a,0
	ld ($-1),a
	ld hl,gamma ; 
	ld a,(hl)
	adc a,0
	;ld (hl),a ;10=   
	endif

CUBE_VERTICES
;x,y,z
        DB sz,sz,sz
        DB sz,sz,-sz
        DB sz,-sz,-sz
        DB sz,-sz,sz

        DB -sz,sz,sz
        DB -sz,sz,-sz
        DB -sz,-sz,-sz
        DB -sz,-sz,sz


line_slow
;de=xy1
;hl=xy2
;x=#80..#ff ;    H
;y=#80..#ff
;a=dx
	add a,a
	 if 1==1
	jr nc,sHORN_dxpos
	ex de,hl
	neg
sHORN_dxpos
	ld d,a ;dx>=0
	 else
	ld d,a ;dx
;d=dx=-31..+31?
	ld a,#24 ;inc h
	ld c,#09 ;rrc c
	jp p,sHORN_dxpos
	xor a
	sub d
	ld d,a ;dx>=0
	ld a,#25 ;dec h
	ld c,#01 ;rlc c
sHORN_dxpos
	ld (sHORNincx1),a
	ld (sHORNincx2),a
	ld a,c
	ld (sHORNrr1),a
	ld (sHORNrr2),a
	 endif
	ld a,e
	sub l
	ld e,a ;dy
;e=dy=-31..+31?
	ld a,#2c ;inc l
	jp p,sHORN_dypos
	xor a
	sub e
	ld e,a ;dy>=0
	ld a,#2d ;dec l
sHORN_dypos
	ld (sHORNincy1),a
	ld (sHORNincy2),a
	ld a,h ;x*2+#80
	sra h
	sra h
	 ;add a,a
	 ;and 7
	 ;inc a
	 ;ld b,a ;(x and 7) + 1
	 ;ld a,1
	 ;rrca
	 ;djnz $-1
	 ld ($+4),a
	 ld a,(tbit)
	 ld c,a ;bit
	LD A,e ;dy
	CP d ;dx
	JR NC,sHORNV ;dy>=dx, dx<=dy
sHORNH ;
	LD A,d
	LD B,d ;dx
	INC B ;dx+1 pixels
	CPL 
	;SCF ; CY=1 
	RRA ;mym:=256-(dx div 2)
	 ex af,af'
	 ld a,(hl)
sHORNH0
	;ex af,af'
	;ld a,(hl)
	or c
	;ld (hl),a
sHORNrr1=$+1
	rrc c
	jp nc,sHORNincx1q
	 ld (hl),a
sHORNincx1=$
	inc h
	 ld a,(hl)
sHORNincx1q
	ex af,af'
	ADD A,e ;mym:=mym+dy
	JP NC,sHORNHexQ
	SUB d ;mym:=mym-dx
	 ex af,af'
	 ld (hl),a
sHORNincy1=$
	inc l
	 ld a,(hl)
	DJNZ sHORNH0
	ret;JP sHORNQ
sHORNHexQ
	 ex af,af'
	DJNZ sHORNH0
	ret;JP sHORNQ
sHORNV ;
	LD B,e ;dy
	INC B ;dy+1 pixels
	CPL
	SCF ;CY=1
	RRA ;xm:=256-(dy div 2)
sHORNV0
	ex af,af'
	ld a,(hl)
	or c
	ld (hl),a
	ex af,af'
	ADD A,d ;xm:=xm+dx
	JP NC,sHORNVQ
	SUB e ;xm:=xm-dy {dy<>0!!!}
sHORNrr2=$+1
	rrc c
	jp nc,$+4
sHORNincx2=$
	inc h
sHORNVQ
sHORNincy2=$
	inc l
	DJNZ sHORNV0 
sHORNQ
	ret

	
	
	
	
	
	
	
	
	
		;:
;3=sin(A+B+C)
;2=sin(A-B+C)
;1=sin(A-B-C)
;0=sin(A+B-C)

;2=cos(A+B-C)
;3=cos(A-B-C)
;1=cos(A-B+C)
;0=cos(A+B+C)

;                

 ;a1
;1=sin(A-B-C)
;0=sin(A+B-C)
;3=sin(A+B+C)
;2=sin(A-B+C)

;1=cos(A-B+C)
;0=cos(A+B+C)
;2=cos(A+B-C) ;!
;3=cos(A-B-C) ;!
	ld l,a
	ldi ;sin(A-B-C)
	add a,b ;2B
	ld l,a
	ldi ;sin(A+B-C)
	add a,c ;2C
	ld l,a
	ldi ;sin(A+B+C)
	sub b ;2B
	ld l,a
	ldi ;sin(A-B+C)
	add a,#40 ;cos
	ld l,a
	ldi ;cos(A-B+C)
	add a,b ;2B
	ld l,a
	ldi ;cos(A+B+C)
	sub c ;2C
	ld l,a
	inc de
	ldi ;cos(A+B-C)
	sub b ;2B
	ld l,a
	ld a,(hl)
	ld (),a ;cos(A-B-C)

 ;a2
;1=sin(A-B-C)
;2=sin(A-B+C)
;3=sin(A+B+C)
;0=sin(A+B-C)

;2=cos(A+B-C) ;!
;0=cos(A+B+C)
;1=cos(A-B+C) ;!
;3=cos(A-B-C)

 ;b1
;0=sin(A+B-C)
;3=sin(A+B+C)
;2=sin(A-B+C)
;1=sin(A-B-C)

;3=cos(A-B-C) ;!
;1=cos(A-B+C) ;!
;0=cos(A+B+C) ;!
;2=cos(A+B-C) ;!

 ;b2
;0=sin(A+B-C)
;1=sin(A-B-C)
;2=sin(A-B+C)
;3=sin(A+B+C)

;0=cos(A+B+C)
;1=cos(A-B+C)
;3=cos(A-B-C) ;!
;2=cos(A+B-C) ;!

 ;c1
;2=sin(A-B+C)
;3=sin(A+B+C)
;0=sin(A+B-C)
;1=sin(A-B-C)

;3=cos(A-B-C) ;!
;2=cos(A+B-C) ;!
;0=cos(A+B+C)
;1=cos(A-B+C)

 ;c2
;2=sin(A-B+C)
;1=sin(A-B-C)
;0=sin(A+B-C)
;3=sin(A+B+C)

;0=cos(A+B+C) ;!
;1=cos(A-B+C) ;!
;3=cos(A-B-C) ;!
;2=cos(A+B-C) ;!


	;ld a,e
	;sub h ;2C
	;ld e,a
	;ld a,(de) ;sin(A+B-C)
	;ld (S1Yarr+0),a
	;ld a,e
	;sub l ;2B
	;ld e,a
	;ld a,(de) ;sin(A-B-C)
	;ld (S1Yarr+1),a
	;ld a,e
	;add a,h ;2C
	;ld e,a
	;ld a,(de) ;sin(A-B+C)
	;ld (S1Yarr+2),a




;hl  :
;Xx
;Yy
;Xx'
;Yy'
	ld e,(hl)
	inc hl
	ld d,(hl) ;de=x
	inc hl
	ex de,hl
mcamx=$+1
	ld bc,0;-camx ;-camx
	add hl,bc
	ld (rotatex),hl
	ex de,hl
	ld e,(hl)
	inc hl
	ld d,(hl) ;de=y
	ex de,hl
mcamy=$+1
	ld bc,0;-camy ;-camy
	add hl,bc
	;ld (rotatey),hl
	ld b,h
	ld c,l


	;push hl
	;ld hl,-(#50) ;maxz     
	;add hl,bc
	;ld a,h
	;or a
	;pop hl
	;jp m,doobjzrange0

	push hl
	ld hl,-#30 ;minz    Z
	add hl,bc
	ld a,h
	or a
	jp p,$+3+3
	ld bc,#30 ;minz
	pop hl


	push hl
	ld hl,-(-#50) ;-#54 ;minx  
	add hl,de
	ld a,h
	or a
	pop hl
	jp m,skipobj
	push hl
	ld hl,-(#50) ;#54 ;maxx  
	add hl,de
	ld a,h
	or a
	pop hl
	jp p,skipobj

	ld a,l
	rla
	sbc a,a
	cp h
	jp nz,skipobj
	; hl=-128..+127


	if 1==0
	ld a,c
	sub #c0
	sra a
	add a,#c0
	ld c,a
	ld a,e
	sub #c0
	sra a
	add a,#c0
	ld e,a
	ld a,l
	sub #c0
	sra a
	add a,#c0
	ld l,a
	endif

	
		if rotatebase==0
		
ROTATE_VERTICES
;ix=vert
;b=NVERT
;curvert=$+1
        ;LD ix,diamondvert;CUBE_VERTICES
        ;LD IX,VERTROT
        ;LD B,DIANVERT
; 
ROTV0 ;
        PUSH BC
        LD C,(ix)
        INC ix
        LD D,(ix)
        INC ix
        LD E,(ix)
        INC ix
        ;PUSH HL
        CALL ROTATE_VERTEX
	;ROTATE_VERTEX=5447:
;3*MULSIZE = 978
;3*ROTANGLE=3*1458
	;ROTANGLE:
;4*MULSIGNDE=4*300
        ;POP HL
	;sra c
	;sra e
	;sra d ;     ()
        LD (IX),e
        LD (IX+1),d
	ld a,d;c ;z
	sra a
	sra a
	;xor a
curzbase=$+1
	add a,zbase
	ld d,a
	ld e,0
	;dup 1
	;srl d
	;rr e
	;edup
	ld a,(ix) ;x
	call divz ;~1000 (430)
curxbase=$+1
	add a,xbase
	ld (ix),a
	ld a,(ix+1) ;y
	call divz ;~1000 (430)
curybase=$+1
	add a,ybase
	ld (ix+1),a

		ld de,2+1+(3*MAXEDGES)
		add ix,de

        POP BC
        DJNZ ROTV0

        RET 


	endif

	if fastperspective==0

	;ld l,a
;+-7 / 7 => +-.7
;+L   D0     A
	;push bc
	;call DIV
	;dup 6;5 ;   5,  !
	;sla c
	;rl b
	;edup
	;ld a,b
	;pop bc
	;ret
;+-7 / 7 => +-.7
;+A   D0     A
;DIVFAST
;    %nnnnnnYY YYYYYYnn??
;keep DE!
	sra a
	ld h,a
	ld a,0
	rra
	ld l,a
	jp m,DIVFASTNEG
        ;LD A,L
        ;RLA 
        ;SBC A,A
        ;LD H,A
        ;jr nz,DIVFASTNEG
DIVFASTPOS
       ;DUP 7;6
       ; ADD HL,HL ;CY=0
       ;EDUP 
       DUP 8
        SBC HL,DE
        jr nc,$+3
        ADD HL,DE
        RLA 
        ADD HL,HL ;CY=0
       EDUP 
	   org $-1
	   cpl
        RET 
DIVFASTNEG
       ;DUP 7;6
       ; ADD HL,HL ;CY=0
       ;EDUP 
       DUP 8
        ADD HL,DE
        jr nc,$+5
        OR A
        SBC HL,DE
        RLA 
        ADD HL,HL
       EDUP 
	   org $-1
        RET 


	else ;faster perspective

	or a
	ret z
	jp m,divzneg
	ld l,a
	ld h,tlog/256
	;ret
	ld a,(hl)
	ld l,d ;z corrected
	sub (hl)
	ld l,a
	;ld h,2+(tlog/256)
	inc h
	ld a,(hl)
	inc h
	ld h,(hl)
	ld l,a
	dup 6;5 ;   5,  !
	add hl,hl
	edup
	ld a,h
	ret
divzneg
	neg
	ld l,a
	ld h,tlog/256
	;ret
	ld a,(hl)
	ld l,d ;z corrected
	sub (hl)
	ld l,a
	;ld h,2+(tlog/256)
	inc h
	ld a,(hl)
	inc h
	ld h,(hl)
	ld l,a
	dup 6;5 ;   5,  !
	add hl,hl
	edup
	xor a
	sub h
	ret

	endif ;faster perspective

	if lvd_rotate==0
ROTATE_VERTEX
        CALL MULSIZE ;n*0C
        PUSH HL
        LD C,D
        CALL MULSIZE ;n*0C
        LD D,H
        LD C,E
        CALL MULSIZE ;n*0C
        LD E,H
        POP BC
        LD C,B

		;sla c
		;sla d
		;sla e
		
;C,D,E = x,y,z
       ex de,hl
alpha=$+1
        LD DE,tsin
        LD B,L
        CALL ROTANGLE ;C,B>A,B
        ex af,af'
        LD L,B
beta=$+1
        LD E,255&(tsin+162)
        LD C,H,B,L
        CALL ROTANGLE ;C,B>A,B
        LD H,A,L,B
gamma=$+1
        LD E,255&(tsin+27)
        ex af,af'
        LD C,A
        LD B,H
        CALL ROTANGLE ;C,B>A,B
        LD C,A,H,B
       ex de,hl
        RET 

ROTANGLE
;C,B>A,B
;A = C*cos - B*sin
;B = B*cos + C*sin
       PUSH HL
        LD A,B
        LD L,A
        RLA 
        SBC A,A
        LD H,A
        LD A,C
        RLA 
        SBC A,A
        LD B,A
       PUSH BC ;C
       ;LD A,(DE) ;sin
        PUSH HL ;B
        CALL MULSIGNDE ;[B]C*A ;C*sin
        POP BC ;B
       PUSH HL ;C*sin
       ;LD A,(DE) ;sin
        PUSH BC ;B
        CALL MULSIGNDE ;[B]C*A ;B*sin
        POP BC ;B
        LD A,H,HY,A ;B*sin

        LD A,#40
        SUB E
        LD E,A ;cos
       ;LD A,(DE) ;cos
        CALL MULSIGNDE ;[B]C*A ;B*cos
       POP AF ;C*sin
       POP BC ;C
        ADD A,H
       PUSH AF
       ;LD A,(DE) ;cos
        CALL MULSIGNDE ;[B]C*A ;C*cos
        LD A,H
        SUB HY ;B*sin
       POP BC
       POP HL
        RET 

	else ;if lvdrotate
	endif

	
	   ;jp p,$+3+2
	   ;ld a,#80 ;max Z+z
;.   ( ) = +-#20 (  +-#30)
;range0 Z=#000..#050, zspaceshift=#00..#50 (Xshifted=+-#30) 0..2.5 
;range1 Z=#050..#0d0, zspaceshift=#28..#68 (Xshifted=+-#18) 2.5..6.5 
;range2 Z=#0d0..#1d0, zspaceshift=#34..#74 (Xshifted=+-#0c) 6.5..14.5 
;range3 Z=#1d0..#3d0, zspaceshift=#3a..#7a (Xshifted=+-#06) 14.5..30.5 
;range4 Z=#3d0..#7d0, zspaceshift=#3d..#7d (Xshifted=+-#03) 30.5..62.5 


	if 1==0
	ld hl,MATRIX
	ld de,baserot
	ld b,9
delvd	ld a,(hl)
	sra a ;    
	ld (de),a
	inc hl
	inc de
	djnz delvd
	endif

	
;curvert=$+1
        LD HL,BASE_VERTICES
        LD IX,MATRIX
        LD B,3
; 
ROTVB0 ;
	display "ROTVB0=",$
        PUSH BC
        LD C,(HL)
        INC HL
        LD D,(HL)
        INC HL
        LD E,(HL)
        INC HL
        PUSH HL
        CALL ROTATE_VERTEX
        POP HL
        LD (IX),C ;x
        LD (IX+3),E ;y
        LD (IX+6),d ;z
        INC LX
        POP BC
        DJNZ ROTVB0



       ;IF rotatebase;optzero
BASE_VERTICES
        DB sz,0,0
        DB 0,sz,0
        DB 0,0,sz
       ;ENDIF ;optzero

;_k=3-optzero
        ;MACRO DG
        ;DB \0*_k+1,\1*_k+1,\2*_k+1,\3*_k+1
        ;DB 'ttexture-(\4*8)
        ;DB \5
        ;ENDM 

;list of faces, each face = 4 vertices
;ttex nr
;attr
;clockwise
;CUBE1
        ;DG 0,4,7,3,1,7
        ;DG 4,0,1,5,3,7
        ;DG 0,3,2,1,2,7
        ;DG 2,3,7,6,3,7
        ;DG 7,4,5,6,2,7
        ;DG 1,2,6,5,1,7
        ;DB -1
;CUBE2
        ;DG 0,4,7,3,0,7
        ;DG 0,1,5,4,2,7
        ;DG 0,3,2,1,1,7
        ;DG 3,7,6,2,2,7
        ;DG 7,4,5,6,1,7
        ;DG 1,2,6,5,0,7
        ;DB -1

;PLANE
;PLANE1
        ;DG 0,1,5,4,3,4
        ;DG 4,5,1,0,3,4
        ;DB -1
;PLANE2
        ;DG 0,1,5,4,0,#43
        ;DG 4,5,1,0,1,5
        ;DB -1


       IFN 0
PLANE_VERTICES
        DB 0,sz,sz
        DB 0,sz,-sz
        DB 0,-sz,-sz
        DB 0,-sz,sz

        DB sz,sz,0
        DB sz,-sz,0
        DB -sz,-sz,0
        DB -sz,sz,0
       ENDIF 
 
MULSIGNDE
       IF optzero
        LD A,B
        OR C
        LD H,A,L,A
        RET Z
       ENDIF ;optzero
        LD A,(DE)
MULSIGN
; checkvisibility
;+0.7 * +0.7 = +0.15
        ADD A,A
        jr nc,_MULPLUS
        LD L,A
        XOR A
        SUB C
        LD C,A
        SBC A,B
        SUB C
        LD B,A
        XOR A
        SUB L
_MULPLUS
;+0.7 * 0.7 = +0.15
;BC * A = HL
;badmul=$+1
        LD HL,1;0 ;1    (  H)
       DUP 7
        ADD A,A
        jr nc,$+3
        ADD HL,BC
        ADD HL,HL
       EDUP 
        RET 


MULSIZE
        LD A,C
       IF optzero
       OR A
       LD H,A,L,A
       RET Z
       ENDIF 
        RLA 
        SBC A,A
        LD B,A
cursize=$+1
        LD A,127
		add a,a

;+-7 * 7 => +-7.8
;BC   A      HL
;MUL
        LD HL,1;0 ;1    (  H)
       DUP 7
        RLCA 
        jr nc,$+3
        ADD HL,BC
        ADD HL,HL
       EDUP 
        RLCA 
        RET NC
        ADD HL,BC
        RET 


;+-7 / 7 => +-7.8
;+L   D0     BC
DIV
;keep DE!
        LD A,L
        RLA 
        SBC A,A
        LD H,A
        jr nz,DIVNEG
DIVPOS
        ADD HL,HL
       DUP 8
        ADD HL,HL ;CY=0
        SBC HL,DE
        jr nc,$+3
        ADD HL,DE
        RLA 
       EDUP 
        CPL 
        LD B,A
       DUP 8
        ADD HL,HL ;CY=0
        SBC HL,DE
        jr nc,$+3
        ADD HL,DE
        RLA 
       EDUP 
        CPL 
        LD C,A
       INC BC ;good rounding
       SRL B
       RR C
        RET 
DIVNEG
        ADD HL,HL
       DUP 8
        ADD HL,HL
        ADD HL,DE ;HL<0, DE>0
        jr nc,$+5
        OR A
        SBC HL,DE
        RLA 
       EDUP 
        LD B,A
       DUP 8
        ADD HL,HL
        ADD HL,DE
        jr nc,$+5
        OR A
        SBC HL,DE
        RLA 
       EDUP 
        LD C,A
       INC BC ;good rounding
       SCF 
       RR B
       RR C
        RET 

DRS1PUSH
	;exx
	;push hl
	;exx
DRS1    LD A,H ;XL
        EXX
	;ld b,10
	;djnz $
	;117t   ~ 16800t    5 
	;1t ~ 144t
	  or a
	  jp m,$+3+2+3+2
	  cp #40
	  jp m,DRSNO ;0..#3f -        => skip
	  ld a,#80
	   ;ld b,a
	   ld (leftmaskpatch),a
	 rra
	 rra
	 ;rra
	 or %11100000
	 ld d,a
	   ;ld a,b
	   ;cpl
	   ;and 3
	   ;inc a
	   ;ld b,a
	   ;ld a,#ff
	   ;add a,a
	   ;add a,a
	   ;djnz $-2
	   ;ld l,a;(DRSleftbit),a
leftmaskpatch=$+1
	   ld hl,(tleftmask)
	 ld a,hx ;XR
	  or a
	  jp m,$+3+2+3+2
	  cp #40
	  jp p,DRSNO ;#40..#7f -        => skip
	  ld a,#ff
	   ;ld a,hx ;XR
	   ; or a
	   ; jp m,$+3+2+3
	   ; ld h,0;#ff
	   ; jp DRSNH
	  ;ld c,a
	  ld (rightmaskpatch),a
; a=0,         
	   ;cpl
	   ;and 3
	   ;inc a
	   ;ld b,a
	   ;ld a,#ff
	   ;add a,a
	   ;add a,a
	   ;djnz $-2
	ex af,af'
rightmaskpatch=$+1
	ld a,(tleftmask)
	   cpl
	   ld h,a;(DRSrightbit),a
	ex af,af'
DRSNH
	 ;ld a,c
	 rra
	 rra
	 ;rra
	 or %11100000
	 sub d
_maxjr=32
DRScolor=$+1
        LD c,#55      ; 
        JR Z,DRSNSAME ; .  .    
	jr c,DRSNO;ret c ;overflow???
        ;LD B,A
	   add a,a
	   cpl
	   add a,_maxjr*2+2+1
	   ld (DRSjr),a
; jr      3  (   6 ):
;b=0(same):    0t
;b=1(fill 0):  30t (- jp)
;b=2(fill 1):  17t
;b=3(fill 2):  4t
;  4,    xl,xr
;   5,    overflow  jr DRSRMASK:dup N:jr DRSNO:edup
;   2,   jp,   jr
; :
;b=0(same):    0t
;b=1(fill 0):  21t (- jp)
;b=2(fill 1):  6t
;b=3(fill 2): ! 7t
;   5t   djnz  dec hy:jp nz?
	 ld a,(de)
	 xor c
;DRSleftbit=$+1
	 and l;%11100000
	 xor c
	 ld (de),a
	 inc d
	;dec b
	;jr z,DRSRMASK ; 
	ld a,c
      ;LD (DE),A
      ;INC d
      ;DJNZ $-2
	;jp DRSRMASK
DRSjr=$+1
      jr $
	dup _maxjr
	LD (DE),A
	INC d
	edup
	jp DRSRMASK
DRSNSAME ; .  .    
	ld a,l
	or h
	ld h,a
DRSRMASK
	 ld a,(de)
	 xor c
;DRSsamebit=$+1
	 and h;%00000111
	 xor c
	 ld (de),a
DRSNO
        INC e ;Y
        EXX 
        ADD HL,DE;LEFT
        ADD IX,BC;RIGHT
        DEC HY ;hR;
       IF LRKEEP==0
        JR Z,DRS6 ;
        DEC LY ;hL
       ENDIF
        JP NZ,DRS1
      IF LRKEEP
       LD A,LY
lrSUB  SUB 0
lrJC   JR C,DRS6
       LD HY,A
      ENDIF 
	;exx
	;pop hl
	;exx
        CALL LSECT ; LY
lrKEEP
      IF LRKEEP
     ;4t  = 65t  
       LD A,LY
       CP HY
       LD A,48 ;JNC => RSECT
       JR NC,lrKEEPL
     ;LY   => LSECT
       LD A,LY
       ld LY,HY
       ld HY,A
       LD A,56 ;JC => LSECT
lrKEEPL
       LD (lrJC),A
       LD A,HY
       DEC A ; LY    SUB
       LD (lrSUB+1),A
      ENDIF
        JP DRS1PUSH
DRS6
      IF LRKEEP
       LD LY,A
      ENDIF 
	;exx
	;pop hl
	;exx
        CALL RSECT ; HY
       JP NZ,lrKEEP
        RET 

	if 1==0;optzero
	align 256
baserot
	ds 3 ;Xox,Xoy,Xoz
	ds 3 ;Yox,Yoy,Yoz
	ds 3 ;Zox,Zoy,Zoz
	endif


poly_
	db NPOLY
;POLY v1,v2,v3,e1,e2,e3,color ;(e1,e2,e3   v1-v2, v3-v1, v2-v3)
;clockwise
	POLY  0, 1, 2, 0, 4, 1,br2;1
	POLY  0, 2, 3, 4, 3, 2,br2;2
	POLY  0, 3, 7, 3,17,13,br1;3
	POLY  0, 7, 4,17,10, 8,br1;4

	POLY  2, 7, 3,16, 2,13,br3;5
	POLY  2, 6, 7,12,16, 7,br3;6
	POLY  0, 4, 1,10, 0,14,br1;2
	POLY  4, 5, 1, 5,14,11,br1;1

	POLY  4, 6, 5, 9, 5, 6,br2;4
	POLY  4, 7, 6, 8, 9, 7,br2;7
	POLY  1, 5, 6,11,15, 6,br1;5
	POLY  1, 6, 2,15, 1,12,br1;7

edge_
	db NEDGE
;EDGE p1,p2,v1,v2 ;(p1  v1-v2   , p2 )
;bottom (right)
	EDGE  0, 6, 1, 0
	EDGE  0,11, 2, 1
	EDGE  1, 4, 3, 2
	EDGE  1, 2, 0, 3
	;EDGE  0, 1, 0, 2
;top (left)
	EDGE  8, 7, 4, 5
	EDGE  8,10, 5, 6
	EDGE  9, 5, 6, 7
	EDGE  9, 3, 7, 4
	;EDGE  8, 9, 6, 4
;sides
	EDGE  3, 6, 0, 4
	EDGE  7,10, 1, 5
	EDGE 11, 5, 2, 6
	EDGE  4, 2, 3, 7
;diagonals on sides
	EDGE  6, 7, 1, 4
	EDGE 10,11, 1, 6
	EDGE  4, 5, 7, 2
	EDGE  2, 3, 0, 7

	;VERT -(csz),-(csz),-(csz)
	;VERT +csz,-csz,-csz
	;VERT +csz,+csz,-csz
	;VERT -csz,+csz,-csz
	;VERT -csz,-csz,+csz
	;VERT +csz,-csz,+csz
	;VERT +(csz),+(csz),+(csz)
	;VERT -csz,+csz,+csz


;optzero=1
;rotatebase=1;0
;lvd_rotate=1 ;ROTATE_VERT=16000 (MK_ROTS=3142+500 delvd) 3142->1959
;lvd_rotate=0 ;ROTATE_VERT=23200 (ROTVB0=11000)
;fastperspective=0;1 ;10000 t faster but bad precision
;MAXEDGES=8 ;     (  1 , ..    )
;MAXLIGHT=0;4


	if 1==0
ROTATEOBJ
; :
;Y'  Z
;X',Z'  X,Y
; X',Z'   OZanglecam+OZangleobj
; Y',Z'   
;[ X',Y'   ]
;  :
;bc=Y ( =Z')
;hl=X ( =X')
;de=Z ( =Y')
;  :
;bc=Z'
;hl=Y'
;de=X'
	ld a,(frame_azimuth) ;(gamma) ;azimuth (yaw, )
	push de
	call ROTATEOBJPP ;bc,hl ;Z',X'
	pop de
	ex de,hl
	ld a,(beta) ;tangage (pitch)
	push de
	call ROTATEOBJPP ;bc,hl ;Z',Y'
	pop de
	ret
ROTATEOBJPP
;bc,hl  
;xscr = rotatex*cos(a) + rotatey*sin(a)
;yscr = rotatey*cos(a) - rotatex*sin(a)
;bc="rotatex"
;hl="rotatey"
;  de=21+11+21+15=68
;[  =37+39=76]
	  ;ld (rotatecosangle),a
	  ;cpl
	  ;add a,#40+1
	  ;ld (rotatesinangle),a
	 ;push de
	 ld d,tcos/256
	 ld e,a
	 LD A,(DE) ;cos
;rotatecosangle=$+1
	  ;ld a,(tcos)
	ld ly,a;(cosa),a
	ld (rotatey),hl
	push bc ;rotatex
	;push hl ;rotatey
	call mulabc
	;pop bc ;rotatey
	;push hl ;rotatex*cos(a)
rotatey=$+1
	ld bc,0
	 LD A,#40
	 SUB E
	 LD E,A ;sin
	 LD A,(DE) ;sin
;rotatesinangle=$+1
	  ;ld a,(tcos) ;sin
	call mulabcadd
	;hl+=rotatey*sin(a)
	;pop bc ;rotatex*cos(a)
	;add hl,bc ;hl=xscr = rotatex*cos(a) + rotatey*sin(a)
	pop bc ;rotatex

	push hl ; 

	LD A,(DE) ;sin
	neg
	call mulabc
	;hl=rotatex*sin(a)
	ld a,ly ;cos
	ld bc,(rotatey)
	call mulabcadd
	;hl+=rotatey*cos(a)
	;hl= 

	pop bc ; 
	 ;pop de
	ret
	endif

	
	dec a ;neg+cpl = dec a+cpl+cpl
	 rrca
	 rrca
	dup 4;6 ;3    Z
	rrca
	jr c,$+4
	sbc hl,bc
	sra h
	rr l
	edup
	rrca
	jr c,$+4;ret c
	sbc hl,bc
	ret
...
	 rrca
	 rrca
	dup 4;6 ;3    Z
	rrca
	jr nc,$+3
	add hl,bc
	sra h
	rr l
	edup
	rrca
	jr nc,$+3;ret nc
	add hl,bc
	ret

	;push bc
	push de
	
	push af
	;push de
	;ld a,h
	;rra
	 ;cpl
	 ;add a,a
	call xmulabc_h
	;pop bc
	pop af
	 ;cpl
	 ;add a,a
	push hl
	call xmulabc_a
	pop de
	;add hl,de
		
	pop de
	;pop bc
	;sra h
	;rr l
	add hl,hl
	ccf ; add a,%0000010  
	sbc a,a
	add hl,hl
	rla
	add hl,hl
	rla
	ld l,h
	ld h,a
	ret
	
xmulabc_a
;HL = BC * A
;+-15.0 = +-15.0 * +-.7
	;and %11111100
	;ld h,a
	;sla h
	 ld l,0
	 jr c,$+2+2;xmulabcmain_
	 sbc hl,bc
	rla
	 ;ld hl,0
	jr c,$+2+2;xmulabcmain_
;a<0
	sbc hl,de;bc
;xmulabcmain_
;a>=0
	add hl,hl
	dup 5;6
	 jr c,$+3
	 add hl,bc
	rla
	jr c,$+3
	add hl,de;bc
	add hl,hl
	edup
	org $-1
	;ld a,h
	;xor #80
	;ld h,a
	ret

xmulabc_h
	 ret
	ld l,0
	jr c,$+2+2;xmulabcmain_
;a<0
	sbc hl,bc
;xmulabcmain_
;a>=0
	add hl,hl
	dup 5;6
	;rla
	jr c,$+3
	add hl,bc
	add hl,hl
	edup
	org $-1
	ret
	


	else
	ld a,(frame_mcamy_l)
	add a,l
	ld l,a
	ld a,(frame_mcamy_h)
	adc a,h
	ld h,a
	ld a,(frame_mcamx_l)
	add a,c
	ld c,a
	ld a,(frame_mcamx_h)
	adc a,b
	ld b,a
	ld a,(frame_azimuth) ;(gamma) ;azimuth (yaw, )
	push de
	 ld d,tcos/256
	 ld e,a
	 LD A,(DE) ;cos
	ld ly,a;(cosa),a
	ld (DOFLOORPOINTrotatey),hl
	push bc ;rotatex
	call mulabc
DOFLOORPOINTrotatey=$+1
	ld bc,0
	 LD A,#40
	 SUB E
	 LD E,A ;sin
	 LD A,(DE) ;sin
	call mulabcadd ;hl+=rotatey*sin(a)
	pop bc ;rotatex
	LD A,(DE) ;sin
	pop de
;	 bit 7,h ;Z
;	 ret nz;jp nz,skipfloorpoint ;   (695-7t   ,   )
	push hl ; 
	neg
	call mulabc ;hl=rotatex*sin(a)
	ld a,ly ;cos
	ld bc,(DOFLOORPOINTrotatey)
	call mulabcadd ;hl+=rotatey*cos(a) ;hl= 
	pop bc ; 
	 ;bit 7,b ;Z
	 ;ret nz;jp nz,skipfloorpoint
	dup 1
	sra b
	rr c
	sra h
	rr l
	edup
	ex de,hl
	ld a,(frame_mcamz_l)
	add a,l
	ld l,a
	ld a,(frame_mcamz_h)
	adc a,h
	ld h,a
	ld a,(beta) ;tangage (pitch)
	push de
	 ld d,tcos/256
	 ld e,a
	 LD A,(DE) ;cos
	ld ly,a;(cosa),a
	ld (DOFLOORPOINTrotatey2),hl
	push bc ;rotatex
	call mulabc
DOFLOORPOINTrotatey2=$+1
	ld bc,0
	 LD A,#40
	 SUB E
	 LD E,A ;sin
	 LD A,(DE) ;sin
	call mulabcadd ;hl+=rotatey*sin(a)
	pop bc ;rotatex
	LD A,(DE) ;sin
	pop de
;	 bit 7,h ;Z
;	 ret nz;jp nz,skipfloorpoint ;   Z
	push hl ; 
	neg
	call mulabc ;hl=rotatex*sin(a)
	ld a,ly ;cos
	ld bc,(DOFLOORPOINTrotatey2)
	call mulabcadd ;hl+=rotatey*cos(a) ;hl= 
	pop bc ; 
	;bit 7,b ;Z
	;ret nz;jp nz,skipfloorpoint
	dup 1
	sra b
	rr c
	sra h
	rr l
	edup
	endif

	
sinZXpatch=$+1
	ld a,(tcos) ;%ssaaaaa? !
	 cpl
	and %11111100
	 ld l,a
cosZXpatch=$+1
	ld a,(tcos) ;%ssaaaaa? !
	 cpl
	and   %11111100
	add a,%00000010 ;      +-#3ff
	add a,a
	ld h,a ;  bc
	 ld a,l ;  de

cosZXpatch2=$+1
	ld a,(tcos) ;%ssaaaaa? !
	 cpl
	and %11111100
	 ld l,a
sinZXpatchneg=$+1
	ld a,(tcos) ;%ssaaaaa? !
	 cpl
	and   %11111100
	add a,%00000010 ;      +-#3ff
	add a,a
	ld h,a ;  bc
	 ld a,l ;  de
	
sinZYpatch=$+1
	ld a,(tcos) ;%ssaaaaa? !
	 cpl
	and %11111100
	 ld l,a
cosZYpatch=$+1
	ld a,(tcos) ;%ssaaaaa? !
	 cpl
	and   %11111100
	add a,%00000010 ;      +-#3ff
	add a,a
	ld h,a ;  bc
	 ld a,l ;  de

cosZYpatch2=$+1
	ld a,(tcos) ;%ssaaaaa? !
	 cpl
	and %11111100
	 ld l,a
sinZYpatchneg=$+1
	ld a,(tcos) ;%ssaaaaa? !
	 cpl
	and   %11111100
	add a,%00000010 ;      +-#3ff
	add a,a
	ld h,a ;  bc
	 ld a,l ;  de

		if SORTPOLY==0

DOOBJ
;a=OZangleobj
	;ld hy,a;(OZangleobj),a
	ex af,af'
;bc=Y ( =Z')
;hl=X ( =X')
;de=Z ( =Y')
	ADDCAM_ROT ; ret
;bc=Z'
;hl=Y'
;de=X'
	RANGECHECK ; ret
	ld (rangeshiftpatch),a
;range0: ld a (#3e), tsqr/256
;range1: ld a (#3e), tsqr/256
;range2..4: jr (#18), tsqrsmall/256
	 dec a ;range 0   0,     c,   nc!
	 cp rangeshiftjrbase+_rangeshiftsz*(rangeshiftmax-1)-1 ;range 1 
	 ld a,#3e
	 ;jr z,$+2+2
	 jr nc,$+2+2 ;>= (range 0..1) ;> (range 0)
	 ld a,#18 ;range1..4
	 ld (visibility_rangejr),a
	 ld a,tsqr/256 ;   4 
	 jr nc,$+2+2 ;>= (range 0..1)
	 ld a,tsqrsmall/256 ;   2 
	 ld (visibility_tablepatch),a
	ld a,e
	ld (xspaceshift),a
	ld a,l
	ld (yspaceshift),a
	ld a,b
	ld (zspaceshift),a
	ld (zspaceshift2),a
	if DIV8YPROC==0
	ld a,d
	ld (rotatesquashcp),a
	endif
;~200t  
	;ld a,hy ;OZangleobj
	ex af,af'
	jp ROTATE_VERTICES_BASE ;12300(fix 10800..11500)t (  , min 9445  ), 8400..9000t inline (min 7045(6712 DIV8YPROC)(6216 DIV8YPROC  call pos)(5816 DIV8YPROC  )(5215 DIV8YPROC    DIVCHECKOVERFLOW)(5063  jr)  )
;   
	

; (.. 234000t,   drawfaces,drawedges)
; (.. 142000t,   drawfaces,drawedges,copyscreen)
; 5   ,  :
; 92053(77525)t copyscreen      
; 16740(15020)t ROTATEOBJ
; 61500(50000 fixed, 40000(34000) inline)t ROTATE_VERTICES_BASE
; 58000(23000 )t checkvisibility
;131000t drawfaces
; 62000t drawedges
;  6000t  
;---
;    5    276000t = 265xxxt...286xxxt
; 77525t copyscreen       -    
; 14980t ROTATEOBJ -  
; 30000t (inline) ROTATE_VERTICES_BASE
; 23000t () checkvisibility -   
; 67000t drawfaces (  207xxx...213xxx) -   
; 52000t drawedges (  156956...158671) -   
;----  = 264505
; 11495t  ???

;	jr nz,ROTATE_VERTICES_NEWBASE ;    
;	ld a,(alpha) ;
;oldalpha=$+1
;	cp -1
;	ld (oldalpha),a
;	jr nz,ROTATE_VERTICES_NEWBASE ;    
;beta=$+1
;	ld a,(beta) ;
;oldbeta=$+1
;	cp -1
;	ld (oldbeta),a ;  ,    ?
;ROTATE_VERTICES_NEWBASE


	if 1==0
mulabc
;HL = BC * A
;+-15.0 = +-15.0 * +-.7
	ld hl,0
mulabcadd
	rlca
	jr nc,mulabcmain_
;a<0
; -1(%11111111) => a=-1(%11111111) =>  (%11111101)
; -2(%11111110) => a=-3(%11111101) =>  (%11111011)
; -3(%11111101) => a=-5(%11111011) =>  (%11111001)
; -4(%11111100) => a=-7(%11111001) =>  (%11110111)
; -5(%11111011) => a=-9(%11110111) =>  (%11110101)
	sub 2
	;rrca
	;dec a ;neg+cpl = dec a+cpl+cpl
	;rlca
	dup 4;6 ;3    Z
	rlca
	jr c,$+4
	sbc hl,bc
	sra b
	rr c
	edup
	rlca
	ret c
	sbc hl,bc
	ret
mulabcmain_
;a>=0
	dup 4;6 ;3    Z
	rlca
	jr nc,$+3
	add hl,bc
	sra b
	rr c
	edup
	rlca
	ret nc
	add hl,bc
	ret
	endif

	if 1==0
;z' = z1' + (z2'-z1')*t
	ld l,(ix+4) ;z2
	ld h,(ix+5) ;z2 HSB
	ld e,(ix+4-FLOORPOINTSZ) ;z1
	ld d,(ix+5-FLOORPOINTSZ) ;z1 HSB
	call submul16 ;(hl-de)*bc => hl (+-7.8)
	ld e,(ix+4-FLOORPOINTSZ) ;z1
	ld d,(ix+5-FLOORPOINTSZ) ;z1 HSB
	add hl,de
	push hl ;z'
;y' = y1' + (y2'-y1')*t
	ld l,(ix+2) ;y2
	ld h,(ix+3) ;y2 HSB
	ld e,(ix+2-FLOORPOINTSZ) ;y1
	ld d,(ix+3-FLOORPOINTSZ) ;y1 HSB
	call submul16 ;(hl-de)*bc => hl (+-7.8)
	ld e,(ix+2-FLOORPOINTSZ) ;y1
	ld d,(ix+3-FLOORPOINTSZ) ;y1 HSB
	add hl,de
	pop de ;z'
	call div16 ;hl/de => bc (+-7.8)
;bc = y'/z'
	ld a,c
	sra b
	rra
	sra b
	rra
	add a,ybase
	endif

	if 1==0
	ld l,(ix-FLOORPOINTSZ) ;x1
	ld h,(ix+1-FLOORPOINTSZ) ;x1 HSB
	ld e,(ix+4-FLOORPOINTSZ) ;z1
	ld d,(ix+5-FLOORPOINTSZ) ;z1 HSB
	;sbc hl,de
	 jr c,$+2+2+2
	 sbc hl,de
	 jr $+2+1
	 add hl,de
	;push hl ;(x1'+z1')
	ld d,h
	ld e,l
	ld c,(ix) ;x2
	ld b,(ix+1) ;x2 HSB
	or a
	sbc hl,bc
	ld c,(ix+4) ;z2
	ld b,(ix+5) ;z2 HSB
	add hl,bc
	;pop de
	ex de,hl
	call div16 ;hl/de => bc (+-7.8)
	endif

	if 1==0
trydot
;x=de
;y=hl
	ld a,l
	rla
	sbc a,a
	cp h
	jr nz,floorndot0 ;NZ= 
	ld a,l
	add a,ybase
	ld l,a
	ld a,e
	rla
	sbc a,a
	cp d
	jr nz,floorndot0 ;NZ= 
	ld a,e ;x
	add a,xbase
	ld h,a
	ld d,h
	ld e,+#c0
	call line
floorndot0
	ret
	endif

	ld hl,temppoly
;HL=*POLYGON
;,  ,  
        LD c,(HL)
        INC l;HL
	ld a,(oddline)
	rra
        LD a,(HL)
        INC l;HL
	jr c,$+3
	ld a,c
        ;LD (DRScolor),A;COLOR2
	 exx
	 ld c,a ;
	 exx

	 ;ld a,(rangeshiftpatch)
	 ;cp 2*(rangeshiftmax-1)
	 ;ld c,#00
	 ;jr c,DRWPOLYCOLOR
	 ;cp 2*(rangeshiftmax-0)
	 ;ld c,#ff
	 ;jr z,DRWPOLYCOLOR
	;ld c,#55
;DRWPOLYCOLOR

	if 1==1
	ld (leftxpatch),a
	ld (leftmaskpatch),a
leftxpatch=$+1
	ld a,(tx)
	else
	  or a
	  jp m,$+3+2+3+2
	    cp #40
	    jp m,DRSNO ;0..#3f -        => skip
	    ld a,#80
	  ld (leftmaskpatch),a
	 rra
	 rra
	 or %11100000
	endif
	 ld d,a
	 ld a,hx ;XR
	if 1==1
	ld (rightxpatch),a
	ld (rightmaskpatch),a
rightxpatch=$+1
	ld a,(tx)
	else
	  or a
	  jp m,$+3+2+3+2
	    cp #40
	    jp p,DRSNO ;#40..#7f -        => skip
	    ld a,#ff
; a=#ff,         
	  ld (rightmaskpatch),a
	 rra
	 rra
	 or %11100000
	 endif

	 	 if 1==0 ;  
	 ;       
	 ld a,c ;x1
	 cp #40
	 jr nc,$+3
	 sbc a,a
	 ld c,a
	 ld a,e ;x2
	 cp #40
	 jr nc,$+3
	 sbc a,a
	 ld e,a
	 ld a,l ;x3
	 cp #40
	 jr nc,$+3
	 sbc a,a
	 ld l,a
	 endif
