        MAIN "*",#C6
CENTERZ EQU 144;  3D

TBLOG2  EQU #B700;[512] LOG2 X
TB2X    EQU #B900;[256] (2^X)-1 (0<X<1)
TBXX2   EQU #BA00;[256]\ 2*X*X
COSTB   EQU #BB00;[256]/
TBXX    EQU #BC00;[512] X*X
DOTS2D  EQU #BE00;[256] TMP DOT BUFFER
TMPAREA EQU #BF00;[256]

       DISP CODEAREA
        LD A,FIG_chmwidth
        CALL FIG_MKCHMPROG

        LD HL,FIG_PROG
        LD BC,FIG_DDE2
        LD (mkchmselDDE2),BC
        LD HX,FIG_h64
        LD (FIG_CHMSEL1JP),HL
        LD DE,FIG_CHSCRLFT
        LD A,FIG_chmwidth
        PUSH AF,DE
        CALL MKCHMSEL
        POP DE
        CALL FIG_DDE
        POP AF
        LD (FIG_CHMSEL2JP),HL
        CALL MKCHMSEL

        setpg pgclchm
        LD HL,#C000
        LD (CLCHMJP),HL
        LD A,FIG_chmwidth
        LD HX,FIG_h64
        CALL MKCLCHM

        CALL INIT_3D

        CALL FIGMOVE ;     

        CALL CLS

        LD BC,44
        CALL WAITTIME

        LD HL,FIG_IMER
        LD (IMER+1),HL

        LD HL,PIRAMID
        LD BC,256
        CALL FIG_EF
        LD HL,OCTAH
        LD BC,256
        CALL FIG_EF
        LD HL,FOOTBALL
        LD BC,256
        CALL FIG_EF
        LD HL,RUBIK
        LD BC,256-28
        CALL FIG_EF

        CALL CLS

        RET 

FIG_EF
        LD (FIG_addr),HL
        LD (FIG_TIME),BC
FIG_LOOP
        CALL CLCHM

        setpg FIG_pgtrash
        ; #C000..#FFFF  
FIG_addr=$+1
        LD HL,0;RUBIK
        CALL DRAWOBJ

       IF0 atm-1
        LD A,#18
        LD BC,#7FFD
        OUT (C),A
       ELSE 
        setpg #18
       ENDIF 
        ; #C000..#FFFF = #0000..#3FFF
        CALL FIG_CHMSEL
        CALL FIG_CHMOUT
FIG_TIME=$+1
        LD BC,256
        LD HL,(EFTIME)
        OR A
        SBC HL,BC
        JR C,FIG_LOOP
        LD (EFTIME),HL
        RET 

FIG_CHMSEL
;  - CHMSEL1
;  - CHMSEL2
;...
FIG_CHMSELA=$+1
        LD A,#55
        RRCA 
        LD (FIG_CHMSELA),A
        JNC FIG_CHMSEL2
FIG_CHMSEL1 ;
        setpg pgchmsel
FIG_CHMSEL1JP=$+1
        JP 0
FIG_CHMSEL2 ;
        setpg pgchmsel
FIG_CHMSEL2JP=$+1
        JP 0

FIG_IMER
; HL     
        EX (SP),HL
        LD (FIG_IMERJP),HL
;  SP
        LD (FIG_IMERSP),SP
        LD SP,IMSTACK
        PUSH AF,BC,DE
        PUSH IX,IY
        EXX 
        EXA 
        PUSH AF,BC,DE,HL
       LD A,(curpg)
       PUSH AF
        setpg pgmuz
       ;INCLUDE "CALLMUZ",#29
        CALL CALLMUZ

        LD HL,(EFTIME)
        INC HL
        LD (EFTIME),HL

        CALL FIGMOVE

       POP AF
        setpga
        POP HL,DE,BC,AF
        EXX 
        EXA 
        POP IY,IX
        POP DE,BC,AF
FIG_IMERSP=$+1
        LD SP,0
        POP HL
        EI 
FIG_IMERJP=$+1
        JP 0

FIGMOVE
        LD HL,RUBIK+O_ROTZ
        INC (HL)
        DEC HL
        DEC (HL)
        LD A,201
        ADD A,0
        LD ($-1),A
        JNC $+3 ;  
        DEC (HL)
       ;DEC HL
       ;INC (HL)
FIG_Z=$+1
        LD HL,COSTB
        LD A,(HL)
        INC L
        LD (FIG_Z),HL
        SRA A
        ADD A,16
        LD (RUBIK+O_POSZ),A

        LD HL,RUBIK
        LD DE,OCTAH
        LD BC,6
        LDIR 
        LD HL,RUBIK
        LD DE,FOOTBALL
        LD C,6
        LDIR 
        LD HL,RUBIK
        LD DE,PIRAMID
        LD C,6
        LDIR 
        RET 

       IFN layerpart ;   ,  
FIG_CHMOUT
        LD (FIG_CHMOUTSP),SP
chmoa=0
       REPEAT 
       LOCAL 
       IF0 atm-1
        setpg pgscr10
       ELSE 
        setpg #1E
       ENDIF 
        LD IX,FIG_CHMOUTQ0
        JP CHMPROG+(256*chmoa)
FIG_CHMOUTQ0 ;
        LD IX,FIG_CHMOUTQ2
        JP CHMPROG+128+(256*chmoa)
FIG_CHMOUTQ2 ;
       IF0 atm-1
        setpg pgscr11
       ELSE 
        setpg #1F
       ENDIF 
        LD IX,FIG_CHMOUTQ1
        JP CHMPROG+64+(256*chmoa)
FIG_CHMOUTQ1 ;
        LD IX,FIG_CHMOUTQ3
        JP CHMPROG+192+(256*chmoa)
FIG_CHMOUTQ3 ;
       ENDL 
chmoa=chmoa+layerpart
       UNTIL0 chmoa-FIG_h64<1&1
FIG_CHMOUTSP=$+1
        LD SP,0
        RET 

       ELSE ;  
FIG_CHMOUT
        LD (FIG_CHMOUTSP),SP
       IF0 atm-1
        setpg pgscr10
       ELSE 
        setpg #1E
       ENDIF 
        LD IX,FIG_CHMOUTQ0
        JP CHMPROG
FIG_CHMOUTQ0 ;
        LD IX,FIG_CHMOUTQ2
        JP CHMPROG+128
FIG_CHMOUTQ2 ;
       IF0 atm-1
        setpg pgscr11
       ELSE 
        setpg #1F
       ENDIF 
        LD IX,FIG_CHMOUTQ1
        JP CHMPROG+64
FIG_CHMOUTQ1 ;
        LD IX,FIG_CHMOUTQ3
        JP CHMPROG+192
FIG_CHMOUTQ3 ;
FIG_CHMOUTSP=$+1
        LD SP,0
        RET 
       ENDIF 

FIG_MKCHMPROG
;A=FIG_chmwidth (2,4,...,28)
        LD (FIG_mkchmlaywidth),A
        RRCA 
        LD (FIG_mkchmlaywidthdiv2),A
;4  
;LD SP,
;LD DE,:PUSH DE *14
;JP
        LD HL,CHMPROG
        LD DE,FIG_CHSCRLFT
        CALL FIG_MKCHMLAYER
        LD HL,CHMPROG+64
        CALL FIG_MKCHMLAYER
        SET 5,D
        LD HL,CHMPROG+128
        CALL FIG_MKCHMLAYER
        LD HL,CHMPROG+192
FIG_MKCHMLAYER
;HL=code addr
;DE=screen addr ( )
        PUSH DE
        LD C,FIG_h64
       IFN layerpart
       EXX 
       LD B,layerpart
       EXX 
       ENDIF 
;C= 
FIG_MKCHMlay
       PUSH HL
;  
        LD (HL),49
        INC HL
        LD A,E
FIG_mkchmlaywidth=$+1
        ADD A,0;chmwidth
        LD (HL),A
        INC HL
        LD (HL),D
        JNC $+3
        INC (HL)
FIG_mkchmlaywidthdiv2=$+1
        LD B,0;chmwidth/2
FIG_MKCHMln
        INC HL
        LD (HL),33
        INC HL
        INC HL
        INC HL
        LD (HL),229
        DJNZ FIG_MKCHMln
      ;IFN CHMINT
        LD (HL),34 ;LD (..),HL
        INC HL
        LD (HL),E
        INC HL
        LD (HL),D
      ;ENDIF
        INC HL
       ;BC= ?
        LD (HL),195
        PUSH HL
        POP IX
       POP HL
        INC H
        LD (IX+1),L
        LD (IX+2),H
        CALL FIG_DDE2
       IFN layerpart
       EXX 
       DEC B
       JNZ FIG_MKCHMnpart
       LD (IX),#DD
       LD (IX+1),233 ;JP (IX)
       LD B,layerpart
FIG_MKCHMnpart
       EXX 
       ENDIF 
        DEC C
        JNZ FIG_MKCHMlay
        LD (IX),#DD
        LD (IX+1),233 ;JP (IX)
        POP DE
        RET 

FIG_DDE2
        CALL FIG_DDE
FIG_DDE
       IF0 atm-1
        LD A,E
        ADD A,40
        LD E,A
        RET NC
        INC D
        RET 
       ELSE 
        INC D
        LD A,D
        AND 7
        RET NZ
        LD A,E
        ADD A,32
        LD E,A
        RET C
        LD A,D
        ADD A,-8
        LD D,A
        RET 
       ENDIF 

;VIEW ROUTINES

DRAWOBJ
        LD (OBJECT),HL
        LD DE,O_ROTX
        ADD HL,DE
        LD DE,OBJROTX
       DUP 3
        LDI 
       EDUP 

        CALL PROJECT

RENDER
;RENDER OBJECT (EDGES)
        LD HL,(OBJECT)
        LD DE,O_FACE
        ADD HL,DE
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
RNDR    LD A,(HL)
        CP #80
        RET Z
        LD DE,TMPAREA
        LDI 
        LD A,(HL)
        LDI 
        LD LX,A
        LD B,'DOTS2D
RNDR1   LD A,(HL)
        INC HL
        ADD A,A
        LD C,A
        LD A,(BC)
        INC C
        LD (DE),A
        INC E
        LD A,(BC)
        LD (DE),A
        INC E
        DEC LX
        JP NZ,RNDR1
        PUSH HL
;   ?
        LD IX,TMPAREA+2
        LD A,(IX+3)
        SUB (IX+1);(Y2-Y1)
        RRA 
        LD E,A
        LD A,(IX+4)
        SUB (IX+2);(X3-X2)
        RRA 
        LD L,A
        CALL MULS
        PUSH HL
        LD A,(IX+5)
        SUB (IX+3);(Y3-Y2)
        RRA 
        LD E,A
        LD A,(IX+2)
        SUB (IX+0);(X2-X1)
        RRA 
        LD L,A
        CALL MULS
        POP DE
        OR A
        SBC HL,DE
        JP M,RNDR2
        JR Z,RNDR2
; 
        LD HL,TMPAREA
        CALL DRWPOLY
RNDR2   POP HL
        JR RNDR


;- 2D/3D TRANSFORM ---------------------

PROJECT
;ROTATE AND PROJECT ALL VERTS
        LD IX,(OBJECT)
        LD L,(IX+O_VERT)
        LD H,(IX+O_VERT+1)
        LD IY,DOTS2D
PROJ    LD E,(HL)
        INC HL
        LD A,#80
        CP E
        RET Z
        LD D,(HL)
        INC HL
        LD C,(HL)
        INC HL
        PUSH HL
;ROTATE DOT(XYZ)
;IN ANGLES (OBJ_ ROTX,ROTY,ROTZ)
; IN:E,D,C=X,Y,Z  IX=OBJECT
;TRASH ALL, EXCEPT IX,IY
; 12 .    ,  . 
;  ,   9 .
        PUSH BC
        LD A,(OBJROTZ)
        CALL ROTATE;XY
        POP BC
        LD B,D,D,E,E,C
        PUSH BC
        LD A,(OBJROTY)
        CALL ROTATE
        POP BC
        LD C,D,D,E,E,B
       ;PUSH BC
       ;LD A,(OBJROTX)
       ;CALL ROTATE
       ;POP BC
;OUT:C,E,D=X,Y,Z
;
        SRA E,C,D
        LD A,D
        ADD A,(IX+O_POSZ)
        ADD A,CENTERZ
        LD L,A ;Z
        LD A,E
        ADD A,(IX+O_POSY)
        LD H,A ;Y
;
        PUSH HL
        LD A,C
        ADD A,(IX+O_POSX)
        LD H,A ;X
        RLA 
        LD A,H
        CALL FDIVB ;HL(SGN)=A(SGN)/L  CF=SIGN
       SRA L
        LD A,#20
        ADD A,L
        LD (IY),A ;Y  
        INC LY
        POP HL
        LD A,H
        RLA 
        LD A,H
        CALL FDIVB
       SRA L
        LD A,#40
        SUB L
        LD (IY),A ;X  
        INC LY
        POP HL
        JP PROJ

       MACRO mul ;     3000t
       LOCAL 
        LD H,'TBXX
        LD C,(HL)
        INC H
        LD B,(HL) ;L^2
       ;LD A,E
        ADD A,L
        JP PE,MULS1 ;>=128  <-128
        LD L,E
        LD D,(HL)
        DEC H
        LD E,(HL) ;E^2
        LD L,A
        LD A,(HL)
        INC H
        LD H,(HL)
        LD L,A    ;(L+E)^2
        SBC HL,BC,HL,DE
                  ;2*L*E
;        SRA H:RR L
        JP MULEND ;RET
MULS1   LD A,L
        SUB E
        LD L,E
        LD D,(HL)
        DEC H
        LD E,(HL) ;E^2
        LD L,A
        LD A,(HL)
        INC H
        LD H,(HL)
        LD L,A    ;(L-E)^2
        EX DE,HL
        ADD HL,BC ;E^2 + L^2
        SBC HL,DE ;2*L*E
;        SRA H:RR L
MULEND ;RET
       ENDL 
       ENDM 

;ROTATE (X,Y,ANGLE)
; X'=X*COS+Y*SIN
; Y'=Y*COS-X*SIN
; IN:DE=YX[SGN] A=ANGLE
;OUT:DE=YX[SGN]
;TRASH ALL, EXCEPT IX,IY

ROTATE
        LD L,A
        LD H,'COSTB
        LD C,(HL);COS
        SUB #40
        LD L,A
        LD B,(HL);SIN
        LD A,E
        EXA 
        LD A,C
        EXX 
        LD L,A
        EXA 
        LD E,A
        mul
       ;CALL MULS
        PUSH HL
        EXX 
        LD A,D
        EXA 
        LD A,B
        EXX 
        LD L,A
        EXA 
        LD E,A
        mul
       ;CALL MULS
        POP DE
        ADD HL,DE
        PUSH HL
        EXX 
        LD A,E
        EXA 
        EXX 
        LD L,A
        EXA 
        LD E,A
        mul
       ;CALL MULS
        PUSH HL
        EXX 
        LD A,D
        EXA 
        LD A,C
        EXX 
        LD L,A
        EXA 
        LD E,A
        mul
       ;CALL MULS
        POP DE
        OR A
        SBC HL,DE
        LD D,H
        POP HL
        LD E,H
        RET 

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;A[SGN]=A[SGN]*C[SGN]
FMULS
;not used
        SRA A     ;A/2
        LD L,C
        SRA L     ;C/2
        SUB L     ;A/2 - C/2
        LD L,A
        ADD A,C   ;A/2 + C/2
        LD H,'TBXX2
        LD B,(HL) ;2 * (A/2 - C/2)^2
        LD L,A
        LD A,(HL) ;2 * (A/2 + C/2)^2
        SUB B     ;A*C
        RET 

;8*8=16 2*HL=L*E  (ALL SIGNED)
MULS
        LD H,'TBXX
        LD C,(HL)
        INC H
        LD B,(HL) ;L^2
        LD A,L
        ADD A,E
        JP PE,MULS1 ;>=128  <-128
        LD L,E
        LD D,(HL)
        DEC H
        LD E,(HL) ;E^2
        LD L,A
        LD A,(HL)
        INC H
        LD H,(HL)
        LD L,A    ;(L+E)^2
        SBC HL,BC,HL,DE
                  ;2*L*E
;        SRA H:RR L
        RET 
MULS1   LD A,L
        SUB E
        LD L,E
        LD D,(HL)
        DEC H
        LD E,(HL) ;E^2
        LD L,A
        LD A,(HL)
        INC H
        LD H,(HL)
        LD L,A    ;(L-E)^2
        EX DE,HL
        ADD HL,BC ;E^2 + L^2
        SBC HL,DE ;2*L*E
;        SRA H:RR L
        RET 

; 
;,    
DRWPOLY
;HL=*POLYGON
        LD A,(HL)
        INC HL
       LD ($+4),A
       LD A,(TCOLORS)
        LD (DRScolor),A;COLOR
        LD B,(HL)
        INC HL
        DEC B
        RET M
        LD (POLYBEG),HL
        INC HL
        LD E,(HL),D,E
        LD (FTB4+1),HL
        INC HL
        LD (RSBOTT),HL
FTB1    INC HL
        LD A,(HL)
        CP E
        JR NC,FTB2;TOP
        LD E,A,(FTB4+1),HL ;  
        INC HL
        DJNZ FTB1
        JR FTB3
FTB2    INC HL
        CP D
        JR C,FTB5
        LD D,A,(RSBOTT),HL;BOTTOM
FTB5    DJNZ FTB1
FTB3    LD A,D
        CP E
        RET Z
        LD (POLYEND),HL
FTB4    LD HL,0 ;  
        DEC HL
        LD (LSPTR),HL
        LD (RSPTR),HL

        CALL RSECT
        RET Z
        CALL LSECT

        EXX 
        LD HL,(FTB4+1)
        LD L,(HL)
      LD H,'FIG_TCHX
        EXX 
        JP lrKEEP;DRS1

;HL=XL   DE=dXL
;IX=XR   BC=dXR
;LY=hgtL HY=hgtR
;DE'=screen (X=0)

DRS1    LD A,H
        EXX 
        LD D,A;B,A ;XL
   ;NEG
   ;SUB #A0
   ;CP #58
   ;RET NC
       ;LD D,A
        LD E,(HL) ;(TCHX+x)
        INC L
        LD A,HX ;XR
        SUB D;B ;XL
        RET C ;***OVERFLOW->RET*** ;  ()
        JZ DRSNO ; .  .    
        LD B,A
DRScolor=$+1
        LD A,0      ; *8
      LD (DE),A
      INC D
      DJNZ $-2
DRSNO
        EXX 
        ADD HL,DE;LEFT
        ADD IX,BC;RIGHT
        DEC HY ;hR;
        ;JR Z,DRS6 ;
        ;DEC LY ;hL;   (   )
                  ;  =1365t (  =4125t!?!?)
        JP NZ,DRS1                        ;(-lrKEEP <2000t)
      IFN 1
       LD A,LY
lrSUB  SUB 0
lrJC   JC DRS6
       LD HY,A
      ENDIF 
        CALL LSECT ; LY
lrKEEP
      IFN 1
     ;4t  = 65t  
       LD A,LY
       CP HY
       LD A,48 ;JNC => RSECT
       JNC lrKEEPL
     ;LY   => LSECT
       LD A,LY,LY,HY,HY,A
       LD A,56 ;JC => LSECT
lrKEEPL
       LD (lrJC),A
       LD A,HY
       DEC A ; LY    SUB
       LD (lrSUB+1),A
      ENDIF 
        JP DRS1
DRS6
      IFN 1
       LD LY,A
      ENDIF 
        CALL RSECT ; HY
       JP NZ,lrKEEP
        RET 


;TRACE RIGHT, THINK ABOUT ENDPOINT(=ZF)
RSECT
        PUSH HL,DE
RSPTR=$+1
        LD HL,0
RSECT1  LD C,(HL)
        INC HL; X1
        LD B,(HL)
        INC HL; Y1
        EX DE,HL
RSBOTT=$+1
        LD HL,0
        OR A
        SBC HL,DE
        JR Z,RSECT3
POLYEND=$+1
        LD HL,0
        OR A
        SBC HL,DE
        EX DE,HL
        JR NZ,RSECT2
        LD HL,(POLYBEG)
RSECT2  LD E,(HL)
        INC HL; X2
        LD A,(HL)
        DEC HL; Y2
        SUB B
        JR Z,RSECT1
        JR C,RSECT4
        LD (RSPTR),HL
        LD L,A
        LD HY,A;     DY
        LD A,E
        SUB C;DX CF=SIGN
;FASTDIV 8/8=8.8
;HL(SGN)=A(SGN)/L  CF=SIGN
        CALL FDIVB

        LD HX,C,LX,#80
        OR LX
        LD B,H,C,L

RSECT3  POP DE,HL
        RET 
RSECT4  POP DE,HL,HL
        RET ;JR DRSEX

;TRACE LEFT
LSECT
        PUSH BC
LSPTR=$+1
        LD HL,0
LSECT1  LD C,(HL)
        INC HL; X1
        LD B,(HL)
        DEC HL; Y1
POLYBEG=$+1
        LD DE,0
         EX DE,HL
        OR A
        SBC HL,DE
        EX DE,HL
        JR NZ,LSECT2
        LD HL,(POLYEND)
LSECT2  DEC HL
        LD A,(HL); Y2
        DEC HL
        LD E,(HL); X2
        SUB B
        JR Z,LSECT1
        JR C,LSECT3
        LD (LSPTR),HL
        LD L,A,LY,A;     DY
        LD A,E
        SUB C;DX CF=SIGN
;FASTDIV 8/8=8.8
;HL(SGN)=A(SGN)/L  CF=SIGN
        CALL FDIVB
        EX DE,HL
        LD H,C
        LD L,#80

        POP BC
        RET 
LSECT3  POP BC,HL
        RET ;JP DRSEX

;FASTDIV 8/8=8.8
;HL(SGN)=A(SGN)/L  CF=SIGN
FDIVB
        JR NC,$+4
        NEG 
        LD H,'TBLOG2
        LD E,(HL)
        INC H
        LD D,(HL)
        LD L,A
        EXA 
        LD A,(HL)
        DEC H
        ADD A,8
        LD L,(HL)
        LD H,A
        SBC HL,DE ;=LOG(A/L)
        JP P,DIVC1
        LD HL,0 ;LOG<0 =>  <1 =0
        RET 
DIVC1   LD A,H,D,A
        LD H,'TB2X
        LD L,(HL)
        LD H,1
        SUB 8
        JR NC,DIVC2
        LD A,7
        SUB D
        LD ($+4),A
        JR NZ,$
       DUP 7
        ADD HL,HL
       EDUP 
        LD L,H,H,0
        EXA 
        RET NC
        LD A,L
        CPL 
        LD L,A
        DEC H
        INC HL
        RET 
DIVC2   LD A,#0F
        SUB D
        LD ($+4),A
        JR NZ,$
       DUP 7
        ADD HL,HL
       EDUP 
        EXA 
        RET NC
NEGHL   XOR A
        SUB L
        LD L,A
        SBC A,H
        SUB L
        LD H,A
        RET 

        DS .(-$)
TCOLORS
;32 
;: 0..7, 8..14
      ;DUP 2
        DB %00000000

        DB %00001001
        DB %00010010
        DB %00011011
        DB %00100100
        DB %00101101
        DB %00110110
        DB %00111111 ;7
        DB %11001001
        DB %11010010
        DB %11011011
        DB %11100100
        DB %11101101
        DB %11110110
        DB %11111111 ;14
        DB %00010011
        DB %00100101
        DB %00110111
        DB %11010011
        DB %11100101
        DB %11110111 ;20

        DB %10101111 ;21

        DB %10001001
        DB %10010010
        DB %10011011
        DB %10100100
        DB %10101101
        DB %10110110
        DB %10111111 ;28

        DB %10010011
        DB %10100101
        DB %10110111 ;31
      ;EDUP

;- INIT SEQUENCE -----------------------

INIT_3D
        CALL GENXX
        CALL GEN2X
        CALL GENLOG2

;COS X=#80+(X*X)/256 - 
GENCOS  LD HL,COSTB+#80
        LD DE,COSTB+#FF
GNCS1   BIT 6,L
        RET NZ
        XOR A
        LD C,L
        ;SLI C ;!!!
       SLA C
       INC C
        LD B,C
        SET 7,C
GNCS2   JR NC,$+3
        ADD A,B
        RRA 
        SRL C
        JR NZ,GNCS2
        SUB #80
        SET 7,L
        LD (HL),A
        RES 7,E
        LD (DE),A
        CPL 
        SET 7,E
        LD (DE),A
        RES 7,L
        LD (HL),A
        DEC E
        INC L
        JR GNCS1

GENXX
        LD HL,GENXX2
        PUSH HL
        LD DE,TBXX
        PUSH DE
        POP IX
        LD L,E,H,E,B,E,C,E
GNXX    CALL GNXX1
        LD (IX),L
        INC HX
        LD (IX),H
        DEC HX
        ADD HL,BC
        INC C
        ADD HL,BC
        DEC LX
        INC E
        JP P,GNXX
GNXX1   LD A,L
        LD (DE),A
        INC D
        RLA 
        LD A,H
        LD (DE),A
        DEC D
        RLA 
        RET 
GENXX2  LD HL,TBXX,DE,TBXX2
GENX21  LD A,(HL)
        INC H
        RLA 
        LD A,(HL)
        DEC H
        RLA 
        LD (DE),A
        INC L,E
        JR NZ,GENX21
        RET 

;GEN TABLE Y.B=2^(X/256)-1 ,X=(0;1)
GEN2X
        LD IX,TB2X
        LD HL,0
GN2X    LD A,H;ROUNDING
        BIT 7,L
        JR Z,$+3
        INC A
        LD (IX),A
        XOR A
        EXX 
        LD L,A,H,A,E,A
        LD BC,#00B2;(2^1/256)*#10000
        EXX 
        LD BC,#1801
GN2X1   RR C,H,L
        EXX 
        JR NC,GN2X2
        ADD HL,BC
        ADC A,1
GN2X2   RRA 
        RR H,L
        EXX 
        DJNZ GN2X1
        LD A,C
        RRA 
        EXX 
        LD H,L,L,A
        INC LX
        JR NZ,GN2X
        RET 

;GEN TABLE Y.W=LOG2(X) ,X=(1,255)
GENLOG2
        LD HL,TBLOG2
        XOR A
        LD E,A,D,A
        LD (HL),A
        INC H
        LD (HL),#F0
        DEC H
        INC L
GNLG1   LD (HL),D
        INC H
        LD (HL),A
        DEC H
        EXA 
        PUSH HL,DE
        LD DE,#7440
        LD C,L
        SRL C
        RR D
        XOR A
        LD HL,#B8AA
        EXX 
        LD H,A,L,A
        LD B,#10
GNLG2   EXX 
        ADD HL,HL
        ADC A,A
        SBC HL,DE
        SBC A,C
        JR NC,GNLG3
        ADD HL,DE
        ADC A,C
GNLG3   EXX 
        CCF 
        RL L,H
        DJNZ GNLG2
        POP DE
        EXA 
        ADD HL,DE
        ADC A,B
        EX DE,HL
        POP HL
        INC L
        JR NZ,GNLG1
        RET 

RANGE   DW 0,0;LAST RANGE BUFFER

OBJROTX DB 0
OBJROTY DB 0
OBJROTZ DB 0

OBJECT  DW 0

;- STRUCTS -----------------------------

;OBJECT
O_POSX  EQU 0
O_POSY  EQU O_POSX+1
O_POSZ  EQU O_POSY+1
O_ROTX  EQU O_POSZ+1
O_ROTY  EQU O_ROTX+1
O_ROTZ  EQU O_ROTY+1
O_VERT  EQU O_ROTZ+1
O_FACE  EQU O_VERT+2

PRMSZ=30

PIRAMID
        DB 0,0,0
        DS 3
        DW PRMD_V
        DW PRMD_F
PRMD_V  DB PRMSZ,PRMSZ,PRMSZ
        DB -PRMSZ,-PRMSZ,PRMSZ
        DB -PRMSZ,PRMSZ,-PRMSZ
        DB PRMSZ,-PRMSZ,-PRMSZ
        DB #80
PRMD_F  DB #1E,3,1,0,2
        DB #10,3,0,1,3
        DB #04,3,1,2,3
        DB #13,3,3,2,0
        DB #80

OCTSZ=40

OCTAH
        DB 0,0,0
        DS 3
        DW OCTAH_V
        DW OCTAH_F
OCTAH_V
        DB OCTSZ,0,0
        DB -OCTSZ,0,0
        DB 0,OCTSZ,0
        DB 0,-OCTSZ,0
        DB 0,0,OCTSZ
        DB 0,0,-OCTSZ
        DB #80
OCTAH_F DB #03,3,0,4,3
        DB #12,3,0,2,4
        DB #0D,3,4,2,1
        DB #09,3,4,1,3
        DB #02,3,1,5,3
        DB #04,3,3,5,0
        DB #05,3,0,5,2
        DB #08,3,1,2,5
        DB #80

FP2=44/3
;FP1=FP2*809/1000
FP1=FP2*709/1000
FM1=-FP1
FM2=-FP2

FOOTBALL
        DB 0,0,0
        DS 3
        DW FOOTBALL_V
        DW FOOTBALL_F
FOOTBALL_V
;12..16 (0)
        DB FP1*2+FM1,0*2+0,FP2*2+FP2
        DB FP1*2+0,0*2+FM2,FP2*2+FP1
        DB FP1*2+FP2,0*2+FM1,FP2*2+0
        DB FP1*2+FP2,0*2+FP1,FP2*2+0
        DB FP1*2+0,0*2+FP2,FP2*2+FP1
;17..21 (1)
        DB FM1*2+FP1,0*2+0,FP2*2+FP2
        DB FM1*2+0,0*2+FP2,FP2*2+FP1
        DB FM1*2+FM2,0*2+FP1,FP2*2+0
        DB FM1*2+FM2,0*2+FM1,FP2*2+0
        DB FM1*2+0,0*2+FM2,FP2*2+FP1
;22..26 (2)
        DB 0*2+0,FP2*2+FP2,FP1*2+FM1
        DB 0*2+FM2,FP2*2+FP1,FP1*2+0
        DB 0*2+FM1,FP2*2+0,FP1*2+FP2
        DB 0*2+FP1,FP2*2+0,FP1*2+FP2
        DB 0*2+FP2,FP2*2+FP1,FP1*2+0
;27..31 (3)
        DB 0*2+0,FP2*2+FP2,FM1*2+FP1
        DB 0*2+FP2,FP2*2+FP1,FM1*2+0
        DB 0*2+FP1,FP2*2+0,FM1*2+FM2
        DB 0*2+FM1,FP2*2+0,FM1*2+FM2
        DB 0*2+FM2,FP2*2+FP1,FM1*2+0
;32..36 (4)
        DB FM2*2+FM2,FP1*2+FM1,0*2+0
        DB FM2*2+FM1,FP1*2+0,0*2+FP2
        DB FM2*2+0,FP1*2+FP2,0*2+FP1
        DB FM2*2+0,FP1*2+FP2,0*2+FM1
        DB FM2*2+FM1,FP1*2+0,0*2+FM2
;37..41 (5)
        DB FM2*2+FM2,FM1*2+FP1,0*2+0
        DB FM2*2+FM1,FM1*2+0,0*2+FM2
        DB FM2*2+0,FM1*2+FM2,0*2+FM1
        DB FM2*2+0,FM1*2+FM2,0*2+FP1
        DB FM2*2+FM1,FM1*2+0,0*2+FP2
;42..46 (6)
        DB FM1*2+FP1,0*2+0,FM2*2+FM2
        DB FM1*2+0,0*2+FM2,FM2*2+FM1
        DB FM1*2+FM2,0*2+FM1,FM2*2+0
        DB FM1*2+FM2,0*2+FP1,FM2*2+0
        DB FM1*2+0,0*2+FP2,FM2*2+FM1
;47..51 (7)
        DB FP1*2+FM1,0*2+0,FM2*2+FM2
        DB FP1*2+0,0*2+FP2,FM2*2+FM1
        DB FP1*2+FP2,0*2+FP1,FM2*2+0
        DB FP1*2+FP2,0*2+FM1,FM2*2+0
        DB FP1*2+0,0*2+FM2,FM2*2+FM1
;52..56 (8)
        DB 0*2+0,FM2*2+FM2,FM1*2+FP1
        DB 0*2+FM2,FM2*2+FM1,FM1*2+0
        DB 0*2+FM1,FM2*2+0,FM1*2+FM2
        DB 0*2+FP1,FM2*2+0,FM1*2+FM2
        DB 0*2+FP2,FM2*2+FM1,FM1*2+0
;57..61 (9)
        DB 0*2+0,FM2*2+FM2,FP1*2+FM1
        DB 0*2+FP2,FM2*2+FM1,FP1*2+0
        DB 0*2+FP1,FM2*2+0,FP1*2+FP2
        DB 0*2+FM1,FM2*2+0,FP1*2+FP2
        DB 0*2+FM2,FM2*2+FM1,FP1*2+0
;62..66 (10)
        DB FP2*2+FP2,FM1*2+FP1,0*2+0
        DB FP2*2+FP1,FM1*2+0,0*2+FP2
        DB FP2*2+0,FM1*2+FM2,0*2+FP1
        DB FP2*2+0,FM1*2+FM2,0*2+FM1
        DB FP2*2+FP1,FM1*2+0,0*2+FM2
;67..71 (11)
        DB FP2*2+FP2,FP1*2+FM1,0*2+0
        DB FP2*2+FP1,FP1*2+0,0*2+FM2
        DB FP2*2+0,FP1*2+FP2,0*2+FM1
        DB FP2*2+0,FP1*2+FP2,0*2+FP1
        DB FP2*2+FP1,FP1*2+0,0*2+FP2
        DB #80

FdC=12
;2 
fC1=0
fC2=7+7
fC3=21;6+7
fC4=20;5+7

FOOTBALL_F
;A-E
        DB fC3,6,12-FdC,17-FdC,21-FdC,60-FdC,59-FdC,13-FdC
        DB fC4,6,13-FdC,59-FdC,58-FdC,64-FdC,63-FdC,14-FdC
        DB fC3,6,14-FdC,63-FdC,62-FdC,67-FdC,71-FdC,15-FdC
        DB fC4,6,15-FdC,71-FdC,70-FdC,26-FdC,25-FdC,16-FdC
        DB fC2,6,16-FdC,25-FdC,24-FdC,18-FdC,17-FdC,12-FdC
;F-J
        DB fC3,6,22-FdC,26-FdC,70-FdC,69-FdC,28-FdC,27-FdC
        DB fC2,6,22-FdC,27-FdC,31-FdC,35-FdC,34-FdC,23-FdC
        DB fC3,6,23-FdC,34-FdC,33-FdC,19-FdC,18-FdC,24-FdC
        DB fC4,6,19-FdC,33-FdC,32-FdC,37-FdC,41-FdC,20-FdC
        DB fC2,6,21-FdC,20-FdC,41-FdC,40-FdC,61-FdC,60-FdC
;K-O
        DB fC3,6,61-FdC,40-FdC,39-FdC,53-FdC,52-FdC,57-FdC
        DB fC2,6,58-FdC,57-FdC,52-FdC,56-FdC,65-FdC,64-FdC
        DB fC3,6,66-FdC,65-FdC,56-FdC,55-FdC,51-FdC,50-FdC
        DB fC2,6,62-FdC,66-FdC,50-FdC,49-FdC,68-FdC,67-FdC
        DB fC4,6,69-FdC,68-FdC,49-FdC,48-FdC,29-FdC,28-FdC
;P-T
        DB fC3,6,30-FdC,29-FdC,48-FdC,47-FdC,42-FdC,46-FdC
        DB fC4,6,31-FdC,30-FdC,46-FdC,45-FdC,36-FdC,35-FdC
        DB fC3,6,32-FdC,36-FdC,45-FdC,44-FdC,38-FdC,37-FdC
        DB fC4,6,39-FdC,38-FdC,44-FdC,43-FdC,54-FdC,53-FdC
        DB fC2,6,43-FdC,42-FdC,47-FdC,51-FdC,55-FdC,54-FdC

        DB #80


RP2=24
RP1=8
RM1=-8
RM2=-24

RUBIK   DB 0,0,0
        DS 3
        DW RUBIK_V
        DW RUBIK_F
RUBIK_V
;   ( 0..3)
        DB RP1,RP1,RP2
        DB RM1,RP1,RP2
        DB RM1,RM1,RP2
        DB RP1,RM1,RP2
;   ( 4..15)
        DB RP2,RP2,RP2
        DB RP1,RP2,RP2
        DB RM1,RP2,RP2
        DB RM2,RP2,RP2
        DB RM2,RP1,RP2
        DB RM2,RM1,RP2
        DB RM2,RM2,RP2
        DB RM1,RM2,RP2
        DB RP1,RM2,RP2
        DB RP2,RM2,RP2
        DB RP2,RM1,RP2
        DB RP2,RP1,RP2
;    ( 16..27)
        DB RP2,RP2,RP1
        DB RP1,RP2,RP1
        DB RM1,RP2,RP1
        DB RM2,RP2,RP1
        DB RM2,RP1,RP1
        DB RM2,RM1,RP1
        DB RM2,RM2,RP1
        DB RM1,RM2,RP1
        DB RP1,RM2,RP1
        DB RP2,RM2,RP1
        DB RP2,RM1,RP1
        DB RP2,RP1,RP1
;    ( 28..39)
        DB RP2,RP2,RM1
        DB RP1,RP2,RM1
        DB RM1,RP2,RM1
        DB RM2,RP2,RM1
        DB RM2,RP1,RM1
        DB RM2,RM1,RM1
        DB RM2,RM2,RM1
        DB RM1,RM2,RM1
        DB RP1,RM2,RM1
        DB RP2,RM2,RM1
        DB RP2,RM1,RM1
        DB RP2,RP1,RM1
;   ( 40..51)
        DB RP2,RP2,RM2
        DB RP1,RP2,RM2
        DB RM1,RP2,RM2
        DB RM2,RP2,RM2
        DB RM2,RP1,RM2
        DB RM2,RM1,RM2
        DB RM2,RM2,RM2
        DB RM1,RM2,RM2
        DB RP1,RM2,RM2
        DB RP2,RM2,RM2
        DB RP2,RM1,RM2
        DB RP2,RP1,RM2
;   ( 52..55)
        DB RP1,RP1,RM2
        DB RM1,RP1,RM2
        DB RM1,RM1,RM2
        DB RP1,RM1,RM2
        DB #80

;6 
rC1=1+7
rC2=2
rC3=3+7
rC4=4
rC5=6+7
rC6=7+7

RUBIK_F
; 
        DB rC1,4, 0, 1, 2, 3
        DB rC2,4, 4, 5, 0,15
        DB rC3,4, 5, 6, 1, 0
        DB rC4,4, 6, 7, 8, 1
        DB rC5,4, 1, 8, 9, 2
        DB rC6,4, 2, 9,10,11
        DB rC5,4, 3, 2,11,12
        DB rC2,4,14, 3,12,13
        DB rC3,4,15, 0, 3,14
; 
        DB rC4,4, 5, 4,16,17
        DB rC5,4, 6, 5,17,18
        DB rC6,4, 7, 6,18,19
        DB rC1,4, 8, 7,19,20
        DB rC2,4, 9, 8,20,21
        DB rC3,4,10, 9,21,22
        DB rC4,4,11,10,22,23
        DB rC5,4,12,11,23,24
        DB rC6,4,13,12,24,25
        DB rC1,4,14,13,25,26
        DB rC2,4,15,14,26,27
        DB rC3,4, 4,15,27,16
; 
        DB rC1,4,17,16,28,29
        DB rC2,4,18,17,29,30
        DB rC1,4,19,18,30,31
        DB rC2,4,20,19,31,32
        DB rC3,4,21,20,32,33
        DB rC5,4,22,21,33,34
        DB rC6,4,23,22,34,35
        DB rC4,4,24,23,35,36
        DB rC2,4,25,24,36,37
        DB rC1,4,26,25,37,38
        DB rC5,4,27,26,38,39
        DB rC4,4,16,27,39,28
; 
        DB rC2,4,29,28,40,41
        DB rC5,4,30,29,41,42
        DB rC3,4,31,30,42,43
        DB rC6,4,32,31,43,44
        DB rC4,4,33,32,44,45
        DB rC1,4,34,33,45,46
        DB rC5,4,35,34,46,47
        DB rC2,4,36,35,47,48
        DB rC6,4,37,36,48,49
        DB rC3,4,38,37,49,50
        DB rC1,4,39,38,50,51
        DB rC4,4,28,39,51,40
; 
        DB rC2,4,51,52,41,40
        DB rC3,4,52,53,42,41
        DB rC4,4,53,44,43,42
        DB rC5,4,54,45,44,53
        DB rC6,4,47,46,45,54
        DB rC1,4,48,47,54,55
        DB rC2,4,49,48,55,50
        DB rC3,4,50,55,52,51
        DB rC6,4,55,54,53,52

        DB #80


        DS .(-$)
FIG_TCHX
;L=f(X), FIG_chmwidth*4 
        DS 256,#FF;FIG_chmwidth*2 ; 
        ORG (32-FIG_chmwidth)*2+FIG_TCHX
chcurl=FIG_chmwidth*2
        DUP FIG_chmwidth/2
        DB chcurl
        DB chcurl+64
        DB chcurl+128
        DB chcurl+192
        DB chcurl+1
        DB chcurl+65
        DB chcurl+129
        DB chcurl+193
chcurl=chcurl-4
        EDUP 
        ORG FIG_TCHX+256
FIG_PROG
        DISPLAY "end of BLOCK_FIG main code=",$

       ENT  
	   